Index: trunk/zoo-project/zoo-services/arithmetics/makefile.vc
===================================================================
--- trunk/zoo-project/zoo-services/arithmetics/makefile.vc	(revision 348)
+++ trunk/zoo-project/zoo-services/arithmetics/makefile.vc	(revision 363)
@@ -1,10 +1,11 @@
-GEODIR=c:/OSGeo4W/
-TOOLS=c:/Users/djay/GeoLabs/tools/
-CFLAGS=-I$(GEODIR)/include -I$(TOOLS)/include -I../../zoo-kernel/ -I./ -DLINUX_FREE_ISSUE -DDEBUG -DWIN32
-CPP=cl /TP 
+TROOT= ../
+!INCLUDE ../../zoo-kernel/nmake.opt
+
+#CFLAGS=-I$(GEODIR)/include -I$(TOOLS)/include -I../../zoo-kernel/ -I./ -DLINUX_FREE_ISSUE -DDEBUG -DWIN32
+#CPP=cl /TP 
 
 cgi-env/test_service.zo: test_service.c
-	$(CPP) $(CFLAGS) /c test_service.c
-	link /dll /out:cgi-env/test_service.zo ../../zoo-kernel/service_internal.obj ./test_service.obj -L$(TOOLS)/lib/libssl32.dll.a $(GEODIR)/lib/libxml2.lib $(GEODIR)/lib/gdal_i.lib $(TOOLS)/lib/libeay32.dll.a $(TOOLS)/lib/libcrypto.a $(TOOLS)/lib/libssl32.dll.a $(TOOLS)/lib/libintl.lib
+	$(CPP) -DWIN32 -DZOO_SERVICE -DNEED_STRCASESTR $(CFLAGS) /c test_service.c
+	link /dll /out:cgi-env/test_service.zo ../../zoo-kernel/service_internal.obj ../../zoo-kernel/ulinet.obj ../../zoo-kernel/service_internal_ms.obj ../../zoo-kernel/service_internal_js.obj ./test_service.obj $(LDFLAGS)
 
 clean:
Index: trunk/zoo-project/zoo-services/arithmetics/test_service.c
===================================================================
--- trunk/zoo-project/zoo-services/arithmetics/test_service.c	(revision 348)
+++ trunk/zoo-project/zoo-services/arithmetics/test_service.c	(revision 363)
@@ -34,70 +34,9 @@
 	}
 	res=A*B;
-	outputs=(maps*)malloc(sizeof(maps*));
-	outputs->name="Result";
 	char tmp[256];
 	sprintf(tmp,"%i",res);
-	outputs->content=createMap("value",tmp);
-	addMapToMap(&outputs->content,createMap("datatype","float"));
-	addMapToMap(&outputs->content,createMap("uom","meter"));
-	outputs->next=NULL;
-	dumpMaps(outputs);
-  	fprintf(stderr,"\nService internal print\n===\n");
+	setMapInMaps(outputs,"Result","value",tmp);
 	return SERVICE_SUCCEEDED;
   }
 
-  int helloworld1(maps*& conf,maps*& inputs,maps*& outputs){
-    outputs=(maps*)malloc(sizeof(maps*));
-    outputs->name="Result";
-    outputs->content=createMap("value","Hello World");
-    addMapToMap(&outputs->content,createMap("datatype","string"));
-    return SERVICE_SUCCEEDED; 
-  }
-
-  int helloworld(map*& inputs,map*& outputs){
-    outputs=createMap("output_0","Hello World\n");
-    return SERVICE_SUCCEEDED; 
-  }
-
-  int printArguments(map*& inputs,map*& outputs){
-    char *res=(char *)malloc(sizeof(char));
-    map* tmp=inputs;
-    while(tmp!=NULL){
-      res=(char *)realloc(res,strlen(res)+strlen(tmp->value)+strlen(tmp->name)+6);
-      sprintf(res,"%s,\"%s\"=\"%s\"",res,tmp->name,tmp->value);
-      //sprintf(res,"%s,\"%s\"=\"%s\"",res,tmp->name,tmp->value);
-      tmp=tmp->next;
-    }
-    char *tmpVal=strdup(res+1);
-    outputs=createMap("output_0",tmpVal);
-    addToMap(outputs,"output_1",tmpVal);
-
-    /*dumpMap(outputs);
-      dumpMap(inputs);*/
-    return SERVICE_SUCCEEDED; 
-  }
-
-  int buildJsonArrayOfArgs(map*& inputs,map*& outputs){
-    char *res=(char *)malloc(sizeof(char));
-    map* tmp=inputs;
-    while(tmp!=NULL){
-      res=(char *)realloc(res,strlen(res)+strlen(tmp->value)+3);
-      sprintf(res,"%s,\"%s\"",res,tmp->value);
-      tmp=tmp->next;
-    }
-    char *tmpVal;
-    if(strncmp(res,",",1)!=0){
-      free(tmpVal);
-      tmpVal=strdup(res+1);
-      //dumpMap(inputs);      
-    }else
-      tmpVal=strdup(res);
-    tmpVal=(char*)realloc(tmpVal,strlen(tmpVal)+2);
-    sprintf(tmpVal,"[%s]",tmpVal);
-    outputs=createMap("output_0",tmpVal+1);
-    //dumpMap(outputs);
-    //dumpMap(inputs);
-    return SERVICE_SUCCEEDED; 
-  }
-
 }
Index: trunk/zoo-project/zoo-services/arithmetics/test_service.h
===================================================================
--- trunk/zoo-project/zoo-services/arithmetics/test_service.h	(revision 348)
+++ 	(revision )
@@ -1,1 +1,0 @@
-int helloworld(int);